#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2400one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one24004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
 
                         
# -------------------------------------------------------------------------------------------------
# 2400
# -------------------------------------------------------------------------------------------------                                          
shot2one24004xi = {
                  1:'0x0y2399z',
                  2:'0x1589y1798z',
                  3:'0x72y2398z',
                  4:'1004x729y2054z',
                  5:'1007x1289y1755z',
                  6:'1019x1772y1255z',
                  7:'1035x1536y1525z',
                  8:'1036x1883y1067z',
                  9:'103x99y2395z',
                  10:'1061x1221y1772z',
                  11:'109x2147y1066z',
                  12:'10x287y2382z',
                  13:'1104x1467y1544z',
                  14:'1104x1706y1276z',
                  15:'1112x1151y1788z',
                  16:'1127x1817y1088z',
                  17:'114x122y2394z',
                  18:'1157x1079y1804z',
                  19:'1170x1396y1562z',
                  20:'1184x1635y1296z',
                  21:'1198x1005y1819z',
                  22:'1214x1747y1109z',
                  23:'1230x1321y1580z',
                  24:'1235x930y1835z',
                  25:'123x146y2392z',
                  26:'1260x1561y1316z',
                  27:'1266x854y1850z',
                  28:'1287x1244y1598z',
                  29:'1297x1672y1131z',
                  30:'130x172y2390z',
                  31:'1331x1483y1336z',
                  32:'1338x1164y1616z',
                  33:'134x198y2388z',
                  34:'135x225y2385z',
                  35:'135x253y2382z',
                  36:'1376x1593y1152z',
                  37:'137x293y2478z',
                  38:'1384x1082y1634z',
                  39:'138x1990y1333z',
                  40:'1397x1402y1356z',
                  41:'13x19y2399z',
                  42:'1425x999y1651z',
                  43:'1449x1510y1173z',
                  44:'1459x1317y1376z',
                  45:'1515x1231y1395z',
                  46:'1517x1424y1194z',
                  47:'1566x1141y1415z',
                  48:'1581x1335y1214z',
                  49:'158x1812y1565z',
                  50:'162x1544y1830z',
                  51:'1639x1243y1235z',
                  52:'187x2220y891z',
                  53:'220x2127y1088z',
                  54:'23x262y2385z',
                  55:'240x1515y1845z',
                  56:'240x1967y1353z',
                  57:'250x1785y1583z',
                  58:'25x40y2399z',
                  59:'2x24y2399z',
                  60:'2x48y2399z',
                  61:'301x2198y914z',
                  62:'315x1482y1860z',
                  63:'329x2102y1109z',
                  64:'340x1938y1372z',
                  65:'341x1754y1601z',
                  66:'34x2008y1313z',
                  67:'34x237y2388z',
                  68:'35x62y2398z',
                  69:'387x1446y1875z',
                  70:'414x2170y936z',
                  71:'41x211y2390z',
                  72:'428x1718y1619z',
                  73:'42x86y2398z',
                  74:'436x2071y1130z',
                  75:'438x1904y1392z',
                  76:'456x1405y1890z',
                  77:'46x185y2392z',
                  78:'47x110y2396z',
                  79:'49x135y2395z',
                  80:'49x160y2394z',
                  81:'513x1678y1637z',
                  82:'522x1362y1905z',
                  83:'525x2136y958z',
                  84:'533x1865y1411z',
                  85:'541x2034y1152z',
                  86:'585x1315y1919z',
                  87:'594x1633y1654z',
                  88:'626x1821y1431z',
                  89:'633x2096y980z',
                  90:'643x1992y1173z',
                  91:'645x1266y1934z',
                  92:'64x1833y1547z',
                  93:'672x1585y1671z',
                  94:'700x1213y1948z',
                  95:'70x2235y869z',
                  96:'715x1773y1450z',
                  97:'739x2051y1002z',
                  98:'742x1944y1193z',
                  99:'747x1532y1688z',
                  100:'752x1159y1962z',
                  101:'75x58y2398z',
                  102:'800x1102y1975z',
                  103:'801x1720y1469z',
                  104:'818x1476y1705z',
                  105:'82x1568y1814z',
                  106:'838x1892y1214z',
                  107:'841x2000y1023z',
                  108:'844x1043y1989z',
                  109:'883x1662y1488z',
                  110:'884x982y2002z',
                  111:'885x1417y1722z',
                  112:'90x78y2397z',
                  113:'920x920y2015z',
                  114:'931x1834y1235z',
                  115:'940x1944y1045z',
                  116:'948x1354y1739z',
                  117:'952x857y2028z',
                  118:'961x1601y1507z',
                  119:'980x794y2041z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2400one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE24004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400ONE4XI - SUCCEEDED TO PUT SHOT2ONE24004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE24004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400ONE4XI *** FAILED TO PUT SHOT2ONE24004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one24004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one24004xi</nack2put4xi>" 
                    
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
 
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one24004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE2400ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
